unit idio16u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Registry, ExtCtrls ;

type
  TMainFrm = class(TForm)
    Label5: TLabel;
    GroupBox1: TGroupBox;
    ExitButton: TBitBtn;
    Memo1: TMemo;
    CardName: TLabel;
    BeginSample: TButton;
    RunTimer: TTimer;
    RelayOut: TPanel;
    RelayRead: TPanel;
    OptoIn: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    AddressLabel: TLabel;
    procedure ExitButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
   // procedure CardNum, 0ListChange(Sender: TObject);
    procedure RunTimerTimer(Sender: TObject);
    procedure BeginSampleClick(Sender: TObject);

  private
  { Private declarations }
    DriverRegistry:TRegistry;
  public
  { Public declarations }
  end;


var
  MainFrm: TMainFrm;
  Siz:integer;
  CardNum:word;

implementation

uses AIOWDM;

{$R *.DFM}

procedure TMainFrm.FormCreate(Sender: TObject);

begin
    Siz := 16;
    RelayOut.Caption := StringOfChar('0', Siz);
    RelayRead.Caption := StringOfChar('0', Siz);
    OptoIn.Caption := StringOfChar('0', Siz);
end;

procedure TMainFrm.ExitButtonClick(Sender: TObject);
begin
    Close;
end;

procedure TMainFrm.RunTimerTimer(Sender: TObject);
const
   value:array[0..2] of LongWord=(0,0,0);
   i:Integer=0;
var
   j:integer;
   msg: String;
begin
    value[0]:=1 shl i;
    RelOutPortB(CardNum, 0,value[0]);
    value[1] := RelInPortB(CardNum, 0);
    value[2] := RelInPortB(CardNum, 0+1);
    if Siz > 8 then begin
      RelOutPortB(CardNum, 0 + 4, value[0] shr 8);
      value[1] := value[1] + RelInPortB(CardNum, 0 + 4) shl 8;
      value[2] := value[2] + RelInPortB(CardNum, 0 + 4 + 1) shl 8;
    end;
    inc(i);
    i := i mod Siz;
    msg:=StringOfChar('0', Siz);
    for j:=0 to Siz-1 do
        msg[Siz-j]:=chr(ord((value[0] and (1 shl j))>0)+$30);
    RelayOut.Caption := msg;
    for j:=0 to Siz-1 do
        msg[Siz-j]:=chr(ord((value[1] and (1 shl j))>0)+$30);
    RelayRead.Caption := msg;
    for j:=0 to Siz-1 do
        msg[Siz-j]:=chr(ord((value[2] and (1 shl j))>0)+$30);
    OptoIn.Caption := msg;
end;

procedure TMainFrm.BeginSampleClick(Sender: TObject);
begin
    if RunTimer.Enabled = True then Begin
        RunTimer.Enabled:=False;
        BeginSample.Caption:='Perform I/O';
    end else
    begin
        RunTimer.Enabled:=True;
        BeginSample.Caption:='Stop I/O';
    end;
end;

END.
